

#define __ELEVENTH_ARGUMENT(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11, ...) a11

#define __COUNT_ARGS(...) \
   __ELEVENTH_ARGUMENT(dummy, ## __VA_ARGS__, 9,8,7,6,5,4,3,2,1,0)

#define BUILTINS \
  BF(echo,v,s) \
  BF(mul,i,i,i) \
  BF(gogo,v,i,s,i,s,i,s,i,s) \
  BF(stop,i)
  

#define __TYPEv     void
#define __TYPEi     int
#define __TYPEs     char*
#define _TYPE(r)     __TYPE##r
#define _ARGNAME(D)  a##D

#define _DECL(r,D)   _TYPE(r) _ARGNAME(D)

#define  __DECR__10  9
#define  __DECR__9   8
#define  __DECR__8   7
#define  __DECR__7   6
#define  __DECR__6   5
#define  __DECR__5   4
#define  __DECR__4   3
#define  __DECR__3   2
#define  __DECR__2   1
#define  __DECR__1   0
#define  _DECR(V)  __DECR__##V

#define __INCR_1   2
#define __INCR_2   3
#define __INCR_3   4
#define __INCR_4   5
#define __INCR_5   6
#define __INCR_6   7
#define __INCR_7   8
#define __INCR_8   9
#define __INCR_9   10

#define _INCR(V)  __INCR_##V

#define _ITERC0(F,D,COM)  
#define _ITERC1(F,D,COM,a1) F(a1,D)
#define _ITERC2(F,D,COM,a1,a2) COM(F(a1,D) , F(a2,_INCR(D)))
#define _ITERC3(F,D,COM,a1,...)  \
           COM(F(a1,D) , _ITERC2(F,_INCR(D),COM,__VA_ARGS__))
#define _ITERC4(F,D,COM,a1,...) \
           COM(F(a1,D) , _ITERC3(F,_INCR(D),COM,__VA_ARGS__))
#define _ITERC5(F,D,COM,a1,...) \
           COM(F(a1,D) , _ITERC4(F,_INCR(D),COM,__VA_ARGS__))
#define _ITERC6(F,D,COM,a1,...) \
           COM(F(a1,D) , _ITERC5(F,_INCR(D),COM,__VA_ARGS__))
#define _ITERC7(F,D,COM,a1,...) \
           COM(F(a1,D) , _ITERC6(F,_INCR(D),COM,__VA_ARGS__))
#define _ITERC8(F,D,COM,a1,...) \
           COM(F(a1,D) , _ITERC7(F,_INCR(D),COM,__VA_ARGS__))
#define _ITERC9(F,D,COM,a1,...) \
           COM(F(a1,D) , _ITERC8(F,_INCR(D),COM,__VA_ARGS__))
#define _ITERC10(F,D,COM,a1,...) \
           COM(F(a1,D) , _ITERC9(D),COM,__VA_ARGS__))

#define CONCAT(a, b) a ## b
#define CONCAT2(a, b) CONCAT(a, b)

#define _COMMA(a,b)  a,b
#define _NOTHING(a,b) a b

#define FORARGS(F,COM,...) CONCAT2(_ITERC,__COUNT_ARGS(__VA_ARGS__))(F,1,COM, ##__VA_ARGS__)

#define BF(f,r,...)  _TYPE(r) f( FORARGS(_DECL,_COMMA,##__VA_ARGS__) );

BUILTINS
#undef BF

enum { 
#define BF(f,r,...) exf_##f,
BUILTINS
#undef BF
};

#define BF(f,r,...) { #f, exf_##f },
BUILTINS
#undef BF

#define __GETVi  ri= 
#define __GETVs  rs= 
#define __GETVv  
#define _GETV(t) __GETV##t

#define __GETAi(D)  Ai##D = get_int();
#define __GETAs(D)  As##D = get_str();  
#define _GETA(t,D) __GETA##t(D)

#define __PUTA(t,D)  A##t##D
#define _PUTA(t,D)  __PUTA(t,D)

#define BF(f,r,...)  \
  case exf_##f: \
    pop_stack(__COUNT_ARGS(__VA_ARGS__)); \
    FORARGS(_GETA,_NOTHING,##__VA_ARGS__) \
    _GETV(r) f( FORARGS(_PUTA,_COMMA,##__VA_ARGS__) ); \
  break;

BUILTINS
#undef BF
